Imports System.ComponentModel
Imports System.Drawing.Design
Imports System.Drawing.Drawing2D

<ToolboxItem(True), ToolboxBitmap("f:\VB.Net Projects\PL_Grafici\bin\Immagine.bmp")> _
Public Class PL_Grafici
    Inherits System.Windows.Forms.UserControl

#Region " Codice generato da Progettazione Windows Form "

    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'UserControl1 esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    Friend WithEvents Pict As System.Windows.Forms.PictureBox
    Friend WithEvents lblInfo As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Pict = New System.Windows.Forms.PictureBox()
        Me.lblInfo = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'Pict
        '
        Me.Pict.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Pict.Location = New System.Drawing.Point(16, 40)
        Me.Pict.Name = "Pict"
        Me.Pict.Size = New System.Drawing.Size(208, 144)
        Me.Pict.TabIndex = 0
        Me.Pict.TabStop = False
        '
        'lblInfo
        '
        Me.lblInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblInfo.Location = New System.Drawing.Point(64, 56)
        Me.lblInfo.Name = "lblInfo"
        Me.lblInfo.Size = New System.Drawing.Size(120, 72)
        Me.lblInfo.TabIndex = 2
        Me.lblInfo.Text = "pietro.libro@jumpy.it"
        Me.lblInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'PL_Grafici
        '
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblInfo, Me.Pict})
        Me.Name = "PL_Grafici"
        Me.Size = New System.Drawing.Size(256, 224)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Dichiarazioni variabili private"
    Private _DivisioniAsseX As Integer = 10
    Private _DivisioniAsseY As Integer = 10

    Private _SpessoreLineaGrafico As Single = 1

    Private _ColoreAsseOrizzontale As Color = Color.BlanchedAlmond
    Private _ColoreAsseVerticale As Color = Color.AliceBlue
    Private _ColoreGrafico As Color = Color.Black
    Private _ColoreEtichette As Color = Color.Red

    Private _PenAsseOrizzontale As Pen
    Private _PenAsseVerticale As Pen
    Private _PenGrafico As Pen
    Private _BrEtichetta As Brush

    Private IntervalloOrizzontale As Integer = 0
    Private IntervalloVerticale As Integer = 0

    Private _Gr As Graphics
    Private _GBmp As Bitmap

    Private _OrigineGrafico As Drawing.ContentAlignment = ContentAlignment.MiddleCenter 'Per default parte dal centro
    Private _OrigX As Single = 0
    Private _OrigY As Single = 0

    Private _PuntiGrafico As New Hashtable(100)

#End Region

    <Description("Indica il modo in cui il grafico sar disegnato")> _
    Public Enum TipoGrafico
        Curva = 1
        Linea = 0
    End Enum
    <Description("Disegna gli assi del grafico, ed inizializza le propriet")> _
    Public Sub InizializzaGrafico()
        Try
            'Nasconde la label d'informazione
            lblInfo.Visible = False

            _GBmp = New Bitmap(Pict.Width, Pict.Height, Imaging.PixelFormat.Format32bppArgb)
            _Gr = Graphics.FromImage(_GBmp)


            Dim MetaOrizzontale As Single = CSng(Pict.Width / 2)
            Dim MetaVerticale As Single = CSng(Pict.Height / 2)

            'Divide la parte 
            Dim Dx As Integer = (Pict.Width - MetaOrizzontale) / (_DivisioniAsseX / 2)
            Dim Sx As Integer = (Pict.Height - MetaVerticale) / (_DivisioniAsseY / 2)

            IntervalloOrizzontale = Dx
            IntervalloVerticale = Sx

            Select Case _OrigineGrafico
                Case ContentAlignment.BottomCenter  'In basso al centro
                    _OrigX = MetaOrizzontale
                    _OrigY = Pict.Height
                Case ContentAlignment.BottomLeft    'In basso a sinistra
                    _OrigX = 0
                    _OrigY = Pict.Height
                Case ContentAlignment.BottomRight   'In basso a destra
                    _OrigX = Pict.Width
                    _OrigY = Pict.Height
                Case ContentAlignment.MiddleCenter  'Al centro 'DEFAULT
                    _OrigX = MetaOrizzontale
                    _OrigY = MetaVerticale
                Case ContentAlignment.MiddleLeft    'Al centro a sinistra
                    _OrigX = 0
                    _OrigY = MetaVerticale
                Case ContentAlignment.MiddleRight   'Al centro a destra
                    _OrigX = Pict.Width
                    _OrigY = MetaVerticale
                Case ContentAlignment.TopCenter     'In Alto al centro
                    _OrigX = MetaOrizzontale
                    _OrigY = 0
                Case ContentAlignment.TopLeft       'In Alto a sinistra
                    _OrigX = 0
                    _OrigY = 0
                Case ContentAlignment.TopRight      'In alto a destra
                    _OrigX = Pict.Width
                    _OrigY = 0
            End Select

            Dim I As Integer

            'Disegna le divisioni verticali
            For I = 1 To (_DivisioniAsseX / 2)
                'A Destra
                _Gr.DrawLine(_PenAsseVerticale, MetaOrizzontale + (I * Dx), 0, MetaOrizzontale + (I * Dx), Pict.Height)
                'A Sinistra
                _Gr.DrawLine(_PenAsseVerticale, MetaOrizzontale + (-I * Dx), 0, MetaOrizzontale + (-I * Dx), Pict.Height)
            Next

            'Disegna le divisioni verticali
            For I = 1 To (_DivisioniAsseY / 2)
                'Sopra 
                _Gr.DrawLine(_PenAsseOrizzontale, 0, MetaVerticale - (I * Sx), Pict.Width, Pict.Height - MetaVerticale - (I * Sx))
                'Sotto
                _Gr.DrawLine(_PenAsseOrizzontale, 0, MetaVerticale - (-I * Sx), Pict.Width, Pict.Height - MetaVerticale - (-I * Sx))
            Next

            'Disegna gli assi centrali

            'AsseOrizzontale
            _Gr.DrawLine(Pens.Black, CSng(Pict.Width / 2), 0, CSng(Pict.Width / 2), CSng(Pict.Height))
            'AsseVerticale
            _Gr.DrawLine(Pens.Black, 0, CSng(Pict.Height / 2), Pict.Width, CSng(Pict.Height / 2))

            'Imposta il colore dell'etichette
            _BrEtichetta = New SolidBrush(_ColoreEtichette)

            'Sospende tutto e manda in visualizazzione
            _Gr.Flush()
        Catch ex As Exception
            'Riporta ai valori di default
            _DivisioniAsseX = 10
            _DivisioniAsseY = 10
        End Try
    End Sub
    <Description("Aggiunge un punto da disegnare sul grafico")> _
    Public Sub AggiungiPunto(ByVal X As Single, ByVal Y As Single, ByVal Etichetta As String)
        _PuntiGrafico.Add(_PuntiGrafico.Count, New PuntoGrafico(X, Y, Etichetta))
    End Sub
    <Description("Routine che disegna il grafico sul controllo")> _
    Public Sub DisegnaGrafico(ByVal TipoGrafico As TipoGrafico)
        'Setta il colore del grafico
        Try
            _PenGrafico = New Pen(_ColoreGrafico, _SpessoreLineaGrafico)

            Dim I As Integer = 0
            Dim J As Integer

            Dim Pa As New GraphicsPath()

            Dim P As PuntoGrafico
            Dim R() As PointF
            ReDim R(_PuntiGrafico.Count - 1)

            Dim Pf As PointF

            For J = 0 To _PuntiGrafico.Count - 1

                Pf.X = _OrigX + (IntervalloOrizzontale * _PuntiGrafico(J).X)
                Pf.Y = _OrigY - (IntervalloVerticale * _PuntiGrafico(J).Y)

                'Disegna l'etichetta sul grafico            
                _Gr.DrawString(_PuntiGrafico(J).Etichetta, Me.Font, _BrEtichetta, Pf.X, Pf.Y)

                '--------------------------------------------------------------------------
                'E' possibile fare delle personalizzazioni in questo punto,
                'Come ad esempio disegnare dei pallini sui punti del grafico
                '_Gr.FillEllipse(Brushes.Red, Pf.X - 3, Pf.Y - 3, 6, 6)
                '--------------------------------------------------------------------------

                R(J) = Pf
            Next

            For Each P In _PuntiGrafico.Values
                Pf.X = _OrigX + (IntervalloOrizzontale * P.X)
                Pf.Y = _OrigY - (IntervalloVerticale * P.Y)
                I += 1
            Next

            'Controlla se deve disegnare curve o linee
            If TipoGrafico = TipoGrafico.Linea Then
                Pa.AddLines(R)
            Else
                Pa.AddCurve(R)
            End If

            'Disegna il grafico
            _Gr.DrawPath(_PenGrafico, Pa)
            'Sospende qualsiasi operazione e disegna il grafico
            _Gr.Flush()
        Catch ex As Exception
            MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Public Sub Zoom(ByVal FattoreScala As Single)
        'Operazioni di ridisegno del grafico                

        _DivisioniAsseX *= FattoreScala
        _DivisioniAsseY *= FattoreScala

        InizializzaGrafico()

        MyBase.Invalidate()
    End Sub
    Private Sub PL_Grafici_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Crea l'istanza dell'oggetto Graphics                
        _PenAsseVerticale = New Pen(_ColoreAsseVerticale)
        _PenAsseOrizzontale = New Pen(_ColoreAsseOrizzontale)
    End Sub
    <Description("Posizione e Ridimensiona la PictureBox")> _
    Private Sub PosizionaPictureBox()
        Pict.Top = 0
        Pict.Left = 0
        Pict.Width = MyBase.Width
        Pict.Height = MyBase.Height

        lblInfo.Left = Pict.Width / 2 - lblInfo.Width / 2
        lblInfo.Top = Pict.Height / 2 - lblInfo.Height / 2
    End Sub
    Private Sub PL_Grafici_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        PosizionaPictureBox()
    End Sub
    <Description("Resetta la matrice dei punti del grafico")> _
    Public Sub AzzeraPunti()
        _PuntiGrafico.Clear() 'Rimuove gli oggetti dall'hashtable
    End Sub
    Private Sub PL_Grafici_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Pict.Image = _GBmp
    End Sub
#Region "Propriet"
    <Description("Numero di divisioni X")> _
    Public Property NumeroDivisioniX() As Integer
        Get
            Return _DivisioniAsseX
        End Get
        Set(ByVal Value As Integer)
            _DivisioniAsseX = Value
        End Set
    End Property
    <Description("Numero di divisioni Y")> _
    Public Property NumeroDiDivisioniY() As Integer
        Get
            Return _DivisioniAsseY
        End Get
        Set(ByVal Value As Integer)
            _DivisioniAsseY = Value
        End Set
    End Property
    <Description("Colore del grafico")> _
    Public Property ColoreGrafico() As Color
        Get
            Return _ColoreGrafico
        End Get
        Set(ByVal Value As Color)
            _ColoreGrafico = Value
        End Set
    End Property
    <Description("Colore delle scritte delle etichette")> _
  Public Property ColoreEtichette() As Color
        Get
            Return _ColoreEtichette
        End Get
        Set(ByVal Value As Color)
            _ColoreEtichette = Value
        End Set
    End Property
    <Description("Spessore linea grafico")> _
    Public Property SpessoreLineaGrafico() As Single
        Get
            Return _SpessoreLineaGrafico
        End Get
        Set(ByVal Value As Single)
            _SpessoreLineaGrafico = Value
        End Set
    End Property

    <Description("Indica la propriet da dove partire")> _
    Public Property OrigineGrafico() As Drawing.ContentAlignment
        Get
            Return _OrigineGrafico
        End Get
        Set(ByVal Value As ContentAlignment)
            _OrigineGrafico = Value
        End Set
    End Property


#End Region
End Class

Public Class PuntoGrafico
    Private _X As Single
    Private _Y As Single
    Private _Etichetta As String

    Public Sub New() 'Costruttore vuoto

    End Sub

    Public Sub New(ByVal X As Single, ByVal Y As Single, ByVal Etichetta As String)
        _X = X
        _Y = Y
        _Etichetta = Etichetta
    End Sub

    Public Property X() As Single
        Get
            Return _X
        End Get
        Set(ByVal Value As Single)
            _X = X
        End Set
    End Property
    Public Property Y() As Single
        Get
            Return (_Y)
        End Get
        Set(ByVal Value As Single)
            _Y = Value
        End Set
    End Property
    Public Property Etichetta() As String
        Get
            Return _Etichetta
        End Get
        Set(ByVal Value As String)
            _Etichetta = Value
        End Set
    End Property
End Class
